import processing.serial.*;

int lineFeed = 10;    // Linefeed in ASCII
String input = null;
Serial myPort;  // The serial port
int accel_pitch = 0;  
int accel_y = 0;  
int accel_z = 0; 
int gyro_x = 0;  
int pitch = 0;  
int gyro_pitch = 0;
int corr_pitch = 0;
float accel_vector;
int power = 0;

//PID-variables
float P_gain = 0;
float I_gain = 0;
float D_gain = 0;
float P_gain_A = 0;
float I_gain_A = 0;
float D_gain_A = 0;

//GUI Variables
float PID_Controller_X = 200;
float PID_Controller_Y = 350;


int meterValue = 0; //Value to be displayed on meter
int[] inputArray = new int[7];

void setup() {
  // List all the available serial ports
  println(Serial.list());
  // Open the port you are using at the rate you want:
  myPort = new Serial(this, Serial.list()[5], 9600); //Change 5 to your port number.
  myPort.clear();
  myPort.bufferUntil(lineFeed);
  size(800, 650); 
   
}

void draw() {
  
  //Basic graphics
  background(255,255,255);
  smooth();
  stroke(0);
  strokeWeight(2);
  
  
  //Value 1 box
  noFill();
  textSize(20);
  fill(0);
  
  text("Accel Pitch",20,20);
  text(accel_pitch,20,50);
 
  text("Accel_Y",150,20);
  text(accel_y,150,50);
  
  text("Power",270,20);
  text(power,270,50);
  
  text("Gyro_X",20,90);
  text(gyro_x,20,120);
 
  text("Corr Pitch",150,90);
  text(corr_pitch,150,120);

  text("Gyro Pitch",270,90);
  text(gyro_pitch,270,120);
  
  text("Po",500,20);
  text(accel_vector,550,20);
  
  fill(255,0,0);
  rectMode(CORNER);
  rect(400,50, 200*accel_vector,70);
  
  pushMatrix();
  translate((width/3)*2,240);
  rotate((-1)*(accel_pitch/57.2958));
  rectMode(CENTER);
  rect(0,0,40,100);
  triangle(0,-70,25,-50,-25,-50);
  popMatrix();
  
  pushMatrix();
  translate(width/3,240);
  rotate((-1)*(corr_pitch/57.2958));
  rectMode(CENTER);
  rect(0,0,40,100);
  triangle(0,-70,25,-50,-25,-50);
  popMatrix();
 
  
  //PID Buttons
  pushMatrix();
  translate (PID_Controller_X,PID_Controller_Y);
  rectMode(CORNER);
  noFill();
  rect (400,5,25,25,5);  //P+ button
  rect (400,40,25,25,5); //P- button
  rect (400,105,25,25,5);  //P+ button
  rect (400,140,25,25,5); //P- button
  rect (400,205,25,25,5);  //P+ button
  rect (400,240,25,25,5); //P- button
  
  fill(0,0,0);
  text("+",406,24);
  text("-",408,59);
  text("+",406,124);
  text("-",408,159);
  text("+",406,224);
  text("-",408,259);
  
  popMatrix();
  
  
  //PID regulators
  pushMatrix();
  translate (PID_Controller_X,PID_Controller_Y);
  rectMode(CORNER);
  //P
  text("P",-50,20);
  text(P_gain,-70,50);
  text("P_A",320,20);
  text(P_gain_A,310,50);
  noFill();
  stroke(0);
  strokeWeight(5);
  rect (0,0,300,70,25);
  rect (20,33,260,3);
  fill(255,0,0);
  ellipse (map(P_gain,0,20,35,265),33,50,50);
  //I
  text("I",-50,120);
  text(I_gain,-70,150);
  text("I_A",320,120);
  text(I_gain_A,310,150);
  noFill();
  stroke(0);
  strokeWeight(5);
  rect (0,100,300,70,25);
  rect (20,133,260,3);
  fill(0,255,0);
  ellipse (map(I_gain,0,10,35,265),133,50,50);
  //D
  text("D",-50,220);
  text(D_gain,-70,250);
  text("D_A",320,220);
  text(D_gain_A,310,250);
  noFill();
  stroke(0);
  strokeWeight(5);
  rect (0,200,300,70,25);
  rect (20,233,260,3);
  fill(0,0,255);
  ellipse (map(D_gain,0,10,35,265),233,50,50);
  popMatrix();
    
}

void serialEvent(Serial myPort) {
  int i = 1;
  print("Serial Event!  ");
  while (myPort.available() > 0) {
    input = myPort.readString();
    i++;  
    print(input);
    print("  ");
  }
  myPort.clear();
  
  if(input.charAt(0) == 'A'){
    input = input.substring(1,input.length()-2);
    int parsed = parseInt(input); 
    accel_pitch = parsed;
  }
  else if(input.charAt(0) == 'B'){
    input = input.substring(1,input.length()-2);
    int parsed = parseInt(input); 
    P_gain_A = parsed/1000.0;
  }
  else if(input.charAt(0) == 'C'){
    input = input.substring(1,input.length()-2);
    int parsed = parseInt(input); 
    power = parsed;
  }
  else if(input.charAt(0) == 'D'){
    input = input.substring(1,input.length()-2);
    int parsed = parseInt(input); 
    I_gain_A = parsed/1000.0;
  }
  else if(input.charAt(0) == 'E'){
    input = input.substring(1,input.length()-2);
    int parsed = parseInt(input); 
    corr_pitch = parsed;
  }
  else if(input.charAt(0) == 'F'){
    input = input.substring(1,input.length()-2);
    int parsed = parseInt(input); 
    D_gain_A = parsed/1000.0;
  }
  else if(input.charAt(0) == 'G'){
    input = input.substring(1,input.length()-2);
    int parsed = parseInt(input); 
    accel_vector = (float)parsed/16384;
  }
}

void mouseDragged() {

    if((mouseX > PID_Controller_X && mouseX < PID_Controller_X+300)&&(mouseY > PID_Controller_Y && mouseY < PID_Controller_Y + 70)) {
        P_gain = map(mouseX,PID_Controller_X,PID_Controller_X+300,0,20);
        sendToArduino (1);
    }
    if((mouseX > PID_Controller_X && mouseX < PID_Controller_X+300)&&(mouseY > PID_Controller_Y+100 && mouseY < PID_Controller_Y + 170)) {
        I_gain = map(mouseX,PID_Controller_X,PID_Controller_X+300,0,10);
        sendToArduino (2);
    }    
    if((mouseX > PID_Controller_X && mouseX < PID_Controller_X+300)&&(mouseY > PID_Controller_Y + 200 && mouseY < PID_Controller_Y + 270)) {
        D_gain = map(mouseX,PID_Controller_X,PID_Controller_X+300,0,10);
        sendToArduino (3);
    }
}

void mousePressed() {

    if((mouseX > PID_Controller_X && mouseX < PID_Controller_X+300)&&(mouseY > PID_Controller_Y && mouseY < PID_Controller_Y + 70)) {
        P_gain = map(mouseX,PID_Controller_X,PID_Controller_X+300,0,20);
        sendToArduino (1);
    }
    if((mouseX > PID_Controller_X && mouseX < PID_Controller_X+300)&&(mouseY > PID_Controller_Y+100 && mouseY < PID_Controller_Y + 170)) {
        I_gain = map(mouseX,PID_Controller_X,PID_Controller_X+300,0,10);
        sendToArduino (2);
    }    
    if((mouseX > PID_Controller_X && mouseX < PID_Controller_X+300)&&(mouseY > PID_Controller_Y + 200 && mouseY < PID_Controller_Y + 270)) {
        D_gain = map(mouseX,PID_Controller_X,PID_Controller_X+300,0,10);
        sendToArduino (3);
    }

    // +- Buttons
    //P
    if((mouseX > (PID_Controller_X + 400) && mouseX < (PID_Controller_X+425))&&(mouseY > (PID_Controller_Y + 5) && mouseY < PID_Controller_Y + 30)) {
        P_gain += 0.1;
        sendToArduino (1);
    }
    if((mouseX > (PID_Controller_X + 400) && mouseX < (PID_Controller_X+425))&&(mouseY > (PID_Controller_Y + 40) && mouseY < PID_Controller_Y + 65)) {
        P_gain -= 0.1;
        sendToArduino (1);    
        
    }
    //I
    if((mouseX > (PID_Controller_X + 400) && mouseX < (PID_Controller_X+425))&&(mouseY > (PID_Controller_Y + 105) && mouseY < PID_Controller_Y + 130)) {
        I_gain += 0.1;
        sendToArduino (2);
    }
    if((mouseX > (PID_Controller_X + 400) && mouseX < (PID_Controller_X+425))&&(mouseY > (PID_Controller_Y + 140) && mouseY < PID_Controller_Y + 165)) {
        I_gain -= 0.1;
        sendToArduino (2);    
        
    }
    //D
    if((mouseX > (PID_Controller_X + 400) && mouseX < (PID_Controller_X+425))&&(mouseY > (PID_Controller_Y + 205) && mouseY < PID_Controller_Y + 230)) {
        D_gain += 0.1;
        sendToArduino (3);
    }
    if((mouseX > (PID_Controller_X + 400) && mouseX < (PID_Controller_X+425))&&(mouseY > (PID_Controller_Y + 240) && mouseY < PID_Controller_Y + 265)) {
        D_gain -= 0.1;
        sendToArduino (3);    
        
    }
}

void sendToArduino (int parameter) { 
        
        if(parameter == 1){
          String string = "PV";
          int value = (int)(P_gain*1000); 
          string += str(value);
          string += '$';
          myPort.write(string);    
        }else if(parameter == 2){
          String string = "IV";
          int value = (int)(I_gain*1000); 
          string += str(value);
          string += '$';
          myPort.write(string);    
        } else if(parameter == 3){
          String string = "DV";
          int value = (int)(D_gain*1000); 
          string += str(value);
          string += '$';
          myPort.write(string);    
        }
        
        /*
        myPort.write('P');
        myPort.write((int)map(P_gain,0.0,10.0,0,255));
        myPort.write('I');
        myPort.write((int)map(I_gain,0.0,10.0,0,255));
        myPort.write('D');
        myPort.write((int)map(D_gain,0.0,10.0,0,255)); 
        */

}
